---
title: writing-mode
slug: Web/CSS/writing-mode
tags:
  - CSS
  - CSS Property
  - Layout
  - Reference
  - 'recipe:css-property'
---
<div>{{CSSRef}}</div>

<p>The <strong><code>writing-mode</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> property sets whether lines of text are laid out horizontally or vertically, as well as the direction in which blocks progress. When set for an entire document, it should be set on the root element (<code>html</code> element for HTML documents).</p>

<div>{{EmbedInteractiveExample("pages/css/writing-mode.html")}}</div>

<p>This property specifies the <em>block flow direction</em>, which is the direction in which block-level containers are stacked, and the direction in which inline-level content flows within a block container. Thus, it also determines the ordering of block-level content.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="brush:css no-line-numbers notranslate">/* Keyword values */
writing-mode: horizontal-tb;
writing-mode: vertical-rl;
writing-mode: vertical-lr;

/* Global values */
writing-mode: inherit;
writing-mode: initial;
writing-mode: unset;</pre>

<p>The <code>writing-mode</code> property is specified as one of the values listed below. The flow direction in horizontal scripts is also affected by the <a href="https://www.w3.org/International/questions/qa-scripts.en">directionality of that script</a>, either left-to-right (<code>ltr</code>, like English and most other languages) or right-to-left (<code>rtl</code>, like Hebrew or Arabic).</p>

<h3 id="Values">Values</h3>

<dl>
	<dt><code>horizontal-tb</code></dt>
	<dd>For <code>ltr</code> scripts, content flows horizontally from left to right. For <code>rtl</code> scripts, content flows horizontally from right to left. The next horizontal line is positioned below the previous line.</dd>
	<dt><code>vertical-rl</code></dt>
	<dd>For <code>ltr</code> scripts, content flows vertically from top to bottom, and the next vertical line is positioned to the left of the previous line. For <code>rtl</code> scripts, content flows vertically from bottom to top, and the next vertical line is positioned to the right of the previous line.</dd>
	<dt><code>vertical-lr</code></dt>
	<dd>For <code>ltr</code> scripts, content flows vertically from top to bottom, and the next vertical line is positioned to the right of the previous line. For <code>rtl</code> scripts, content flows vertically from bottom to top, and the next vertical line is positioned to the left of the previous line.</dd>
	<dt><code>sideways-rl</code> {{experimental_inline}}</dt>
	<dd>For <code>ltr</code> scripts, content flows vertically from bottom to top. For <code>rtl</code> scripts, content flows vertically from top to bottom. All the glyphs, even those in vertical scripts, are set sideways toward the right.</dd>
	<dt><code>sideways-lr</code> {{experimental_inline}}</dt>
	<dd>For <code>ltr</code> scripts, content flows vertically from top to bottom. For <code>rtl</code> scripts, content flows vertically from bottom to top. All the glyphs, even those in vertical scripts, are set sideways toward the left.</dd>
	<dt><code>lr</code> {{deprecated_inline}}</dt>
	<dd>Deprecated except for SVG1 documents. For CSS, use <code>horizontal-tb</code> instead.</dd>
	<dt><code>lr-tb</code> {{deprecated_inline}}</dt>
	<dd>Deprecated except for SVG1 documents. For CSS, use <code>horizontal-tb</code> instead.</dd>
	<dt><code>rl</code> {{deprecated_inline}}</dt>
	<dd>Deprecated except for SVG1 documents. For CSS, use <code>horizontal-tb</code> instead.</dd>
	<dt><code>tb</code> {{deprecated_inline}}</dt>
	<dd>Deprecated except for SVG1 documents. For CSS, use <code>vertical-lr</code> instead.</dd>
	<dt><code>tb-lr</code> {{deprecated_inline}}</dt>
	<dd>Deprecated except for SVG1 documents. For CSS, use <code>vertical-lr</code> instead.</dd>
	<dt><code>tb-rl</code> {{deprecated_inline}}</dt>
	<dd>Deprecated except for SVG1 documents. For CSS, use <code>vertical-rl</code> instead.</dd>
</dl>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{CSSInfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{CSSSyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Using_multiple_writing_modes">Using multiple writing modes</h3>

<p>This example demonstrates all of the writing modes, showing each with text in various languages.</p>

<h4 id="HTML">HTML</h4>

<p>The HTML is a {{HTMLElement("table")}} with each writing mode in a row with a column showing text in various scripts using that writing mode.</p>

<pre class="brush: html notranslate">&lt;table&gt;
  &lt;tr&gt;
    &lt;th&gt;Value&lt;/th&gt;
    &lt;th&gt;Vertical script&lt;/th&gt;
    &lt;th&gt;Horizontal (LTR) script&lt;/th&gt;
    &lt;th&gt;Horizontal (RTL) script&lt;/th&gt;
    &lt;th&gt;Mixed script&lt;/th&gt;
  &lt;/tr&gt;
  &lt;tr&gt;
    &lt;td&gt;horizontal-tb&lt;/td&gt;
    &lt;td class="example Text1"&gt;&lt;span&gt;我家没有电脑。&lt;/span&gt;&lt;/td&gt;
    &lt;td class="example Text1"&gt;&lt;span&gt;Example text&lt;/span&gt;&lt;/td&gt;
    &lt;td class="example Text1"&gt;&lt;span&gt;מלל ארוך לדוגמא&lt;/span&gt;&lt;/td&gt;
    &lt;td class="example Text1"&gt;&lt;span&gt;1994年に至っては&lt;/span&gt;&lt;/td&gt;
  &lt;/tr&gt;
  &lt;tr&gt;
    &lt;td&gt;vertical-lr&lt;/td&gt;
    &lt;td class="example Text2"&gt;&lt;span&gt;我家没有电脑。&lt;/span&gt;&lt;/td&gt;
    &lt;td class="example Text2"&gt;&lt;span&gt;Example text&lt;/span&gt;&lt;/td&gt;
    &lt;td class="example Text2"&gt;&lt;span&gt;מלל ארוך לדוגמא&lt;/span&gt;&lt;/td&gt;
    &lt;td class="example Text2"&gt;&lt;span&gt;1994年に至っては&lt;/span&gt;&lt;/td&gt;
  &lt;/tr&gt;
  &lt;tr&gt;
    &lt;td&gt;vertical-rl&lt;/td&gt;
    &lt;td class="example Text3"&gt;&lt;span&gt;我家没有电脑。&lt;/span&gt;&lt;/td&gt;
    &lt;td class="example Text3"&gt;&lt;span&gt;Example text&lt;/span&gt;&lt;/td&gt;
    &lt;td class="example Text3"&gt;&lt;span&gt;מלל ארוך לדוגמא&lt;/span&gt;&lt;/td&gt;
    &lt;td class="example Text3"&gt;&lt;span&gt;1994年に至っては&lt;/span&gt;&lt;/td&gt;
  &lt;/tr&gt;
  &lt;tr&gt;
    &lt;td&gt;sideways-lr&lt;/td&gt;
    &lt;td class="example Text4"&gt;&lt;span&gt;我家没有电脑。&lt;/span&gt;&lt;/td&gt;
    &lt;td class="example Text4"&gt;&lt;span&gt;Example text&lt;/span&gt;&lt;/td&gt;
    &lt;td class="example Text4"&gt;&lt;span&gt;מלל ארוך לדוגמא&lt;/span&gt;&lt;/td&gt;
    &lt;td class="example Text4"&gt;&lt;span&gt;1994年に至っては&lt;/span&gt;&lt;/td&gt;
  &lt;/tr&gt;
  &lt;tr&gt;
    &lt;td&gt;sideways-rl&lt;/td&gt;
    &lt;td class="example Text5"&gt;&lt;span&gt;我家没有电脑。&lt;/span&gt;&lt;/td&gt;
    &lt;td class="example Text5"&gt;&lt;span&gt;Example text&lt;/span&gt;&lt;/td&gt;
    &lt;td class="example Text5"&gt;&lt;span&gt;מלל ארוך לדוגמא&lt;/span&gt;&lt;/td&gt;
    &lt;td class="example Text5"&gt;&lt;span&gt;1994年に至っては&lt;/span&gt;&lt;/td&gt;
  &lt;/tr&gt;
&lt;/table&gt;
</pre>

<h4 id="CSS">CSS</h4>

<div class="hidden">
<p>Some preparatory CSS just to make things look a little better:</p>

<pre class="brush: css notranslate">table {
  border-collapse:collapse;
}
td, th {
  border: 1px black solid; padding: 3px;
}
th {
  background-color: lightgray;
}
.example {
  height:75px;
  width:75px;
}</pre>
</div>

<p>The CSS that adjusts the directionality of the content looks like this:</p>

<pre class="brush:css; notranslate">.example.Text1 span, .example.Text1 {
  writing-mode: horizontal-tb;
  -webkit-writing-mode: horizontal-tb;
  -ms-writing-mode: horizontal-tb;
}

.example.Text2 span, .example.Text2 {
  writing-mode: vertical-lr;
  -webkit-writing-mode: vertical-lr;
  -ms-writing-mode: vertical-lr;
}

.example.Text3 span, .example.Text3 {
  writing-mode: vertical-rl;
  -webkit-writing-mode: vertical-rl;
  -ms-writing-mode: vertical-rl;
}

.example.Text4 span, .example.Text4 {
  writing-mode: sideways-lr;
  -webkit-writing-mode: sideways-lr;
  -ms-writing-mode: sideways-lr;
}

.example.Text5 span, .example.Text5 {
  writing-mode: sideways-rl;
  -webkit-writing-mode: sideways-rl;
  -ms-writing-mode: sideways-rl;
}
</pre>

<h4 id="Result">Result</h4>

<p>This image shows what the output should look like, in case your browser's support for <code>writing-mode</code> is incomplete:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/17087/Screenshot_2020-02-05_21-04-30.png" style="height: 508px; width: 493px;"></p>

<p>{{EmbedLiveSample("Using_multiple_writing_modes", 400, 500)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName("CSS4 Writing Modes", "#block-flow", "writing-mode")}}</td>
			<td>{{Spec2("CSS4 Writing Modes")}}</td>
			<td>Add <code>sideways-lr</code> and <code>sideways-rl</code></td>
		</tr>
		<tr>
			<td>{{SpecName("CSS3 Writing Modes", "#block-flow", "writing-mode")}}</td>
			<td>{{Spec2("CSS3 Writing Modes")}}</td>
			<td>Initial definition</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.writing-mode")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>SVG <code><a href="/en-US/docs/Web/SVG/Attribute/writing-mode">writing-mode</a></code> attribute</li>
	<li>{{Cssxref("direction")}}</li>
	<li>{{Cssxref("unicode-bidi")}}</li>
	<li>{{Cssxref("text-orientation")}}</li>
	<li>{{Cssxref("text-combine-upright")}}</li>
	<li><a href="/docs/Web/CSS/CSS_Logical_Properties">CSS Logical properties</a></li>
	<li><a href="https://www.w3.org/International/articles/vertical-text/">Styling vertical text (Chinse, Japanese, Korean and Mongolian)</a></li>
	<li>Extensive browsers support test results: <a href="https://w3c.github.io/i18n-tests/results/writing-mode-vertical">https://w3c.github.io/i18n-tests/results/writing-mode-vertical</a></li>
</ul>
